searchData={"items":[{"type":"module","title":"ElixirExtensions","doc":"Documentation for `ElixirExtensions`.","ref":"ElixirExtensions.html"},{"type":"module","title":"ElixirExtensions.Core","doc":"Extend Repo with some useful functions.\nAdd this line to your repo:\n\n  use ElixirExtensions.Core","ref":"ElixirExtensions.Core.html"},{"type":"module","title":"ElixirExtensions.Core.MapExt","doc":"Functions to transform maps","ref":"ElixirExtensions.Core.MapExt.html"},{"type":"function","title":"ElixirExtensions.Core.MapExt.atomize_keys/1","doc":"Convert map string keys to :atom keys","ref":"ElixirExtensions.Core.MapExt.html#atomize_keys/1"},{"type":"function","title":"ElixirExtensions.Core.MapExt.deep_merge/2","doc":"Deep merge two maps","ref":"ElixirExtensions.Core.MapExt.html#deep_merge/2"},{"type":"function","title":"ElixirExtensions.Core.MapExt.stringify_keys/1","doc":"Convert map atom keys to strings","ref":"ElixirExtensions.Core.MapExt.html#stringify_keys/1"},{"type":"function","title":"Examples - ElixirExtensions.Core.MapExt.stringify_keys/1","doc":"iex> stringify_keys(%{hello: \"world\"})\n  %{\"hello\" => \"world\"}","ref":"ElixirExtensions.Core.MapExt.html#stringify_keys/1-examples"},{"type":"function","title":"ElixirExtensions.Core.MapExt.underscore_keys/1","doc":"Convert map string camelCase keys to underscore_keys","ref":"ElixirExtensions.Core.MapExt.html#underscore_keys/1"},{"type":"function","title":"Examples - ElixirExtensions.Core.MapExt.underscore_keys/1","doc":"iex> underscore_keys(%{\"helloWorld\" => \"elixirHi\"})\n    %{\"hello_world\" => \"elixirHi\"}","ref":"ElixirExtensions.Core.MapExt.html#underscore_keys/1-examples"},{"type":"module","title":"ElixirExtensions.Core.StringExt","doc":"Functions to string truncate","ref":"ElixirExtensions.Core.StringExt.html"},{"type":"function","title":"ElixirExtensions.Core.StringExt.slugify/2","doc":"Returns `string` as a slug or `nil` if it failed.","ref":"ElixirExtensions.Core.StringExt.html#slugify/2"},{"type":"function","title":"Options - ElixirExtensions.Core.StringExt.slugify/2","doc":"* `:separator` - Replace whitespaces with this string. Leading, trailing or\n  repeated whitespaces are trimmed. Defaults to `-`.\n  * `:lowercase` - Set to `false` if you wish to retain capitalization.\n  Defaults to `true`.\n  * `:truncate` - Truncates slug at this character length, shortened to the\n  nearest word.\n  * `:ignore` - Pass in a string (or list of strings) of characters to ignore.","ref":"ElixirExtensions.Core.StringExt.html#slugify/2-options"},{"type":"function","title":"Examples - ElixirExtensions.Core.StringExt.slugify/2","doc":"iex> slugify(\"Hello, World!\")\n    \"hello-world\"\n\n    iex> slugify(\"Madam, I'm Adam\", separator: \"\")\n    \"madamimadam\"\n\n    iex> slugify(\"StUdLy CaPs\", lowercase: false)\n    \"StUdLy-CaPs\"\n\n    iex> slugify(\"Call me maybe\", truncate: 10)\n    \"call-me\"\n\n    iex> slugify(\"你好，世界\", ignore: [\"你\", \"好\"])\n    \"你好-shi-jie\"","ref":"ElixirExtensions.Core.StringExt.html#slugify/2-examples"},{"type":"function","title":"ElixirExtensions.Core.StringExt.truncate/2","doc":"Copied from https://github.com/ikeikeikeike/phoenix_html_simplified_helpers/blob/master/lib/phoenix_html_simplified_helpers/truncate.ex","ref":"ElixirExtensions.Core.StringExt.html#truncate/2"},{"type":"function","title":"Examples - ElixirExtensions.Core.StringExt.truncate/2","doc":"iex> truncate(\"hello world\", length: 5)\n    \"he...\"","ref":"ElixirExtensions.Core.StringExt.html#truncate/2-examples"},{"type":"module","title":"ElixirExtensions.Ecto.ChangesetExt","doc":"Extend Changeset with some useful functions.\nAdd this line to your schema file:\n\ndefmodule MyApp.Accounts.User do\n  use Ecto.Schema\n  import Ecto.Changeset\n  alias ElixirExtensions.Ecto.ChangesetExt\n  ...\nend\n\nSome extra validations for you to use:\n\ntrim(changeset, :field)\ntrim(changeset, [:field1, :field2])\nvalidate_email(changeset, :field)\nvalidate_url(changeset, field)","ref":"ElixirExtensions.Ecto.ChangesetExt.html"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.email_valid?/1","doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#email_valid?/1"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.ensure_trimmed/2","doc":"Trims the whitespace off both ends of the string.\n\"  John Doe \" -> \"John Doe\"\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:first_name, :last_name, :email])\n      |> trim([:first_name, :last_name])\n      |> trim(:email)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#ensure_trimmed/2"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.trim/1","doc":"Trim whitespace on either end of a string. Account for nil","ref":"ElixirExtensions.Ecto.ChangesetExt.html#trim/1"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.validate_email/2","doc":"Validate emails. Will check mx records in production (see the email_checker library).\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:email])\n      |> validate_email(:email)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_email/2"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.validate_url/2","doc":"Validate URLs. Adds https if a scheme doesn't exist.\neg. \"google.com\" -> \"https://google.com\"\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:website])\n      |> validate_and_fix_url(:website)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_url/2"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.validate_url_works/2","doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_url_works/2"},{"type":"function","title":"ElixirExtensions.Ecto.ChangesetExt.validate_website_link/1","doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_website_link/1"},{"type":"module","title":"ElixirExtensions.Ecto.QueryExt","doc":"Extend Ecto.Query with some useful functions.\nAdd this line to your Context module:\n\n    import Ecto.Query, warn: false\n    alias ElixirExtensions.Ecto.QueryExt","ref":"ElixirExtensions.Ecto.QueryExt.html"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.limit/2","doc":"Limit a the number of results from a query. Can be compined with other queryables\nUserQuery.text_search(\"Kyle\") |> QueryExt.limit(query, 5)","ref":"ElixirExtensions.Ecto.QueryExt.html#limit/2"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.order_by/2","doc":"order_by(query, [:name, :population])\norder_by(query, [asc: :name, desc_nulls_first: :population])","ref":"ElixirExtensions.Ecto.QueryExt.html#order_by/2"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.order_newest_first/1","doc":"Order by newest first","ref":"ElixirExtensions.Ecto.QueryExt.html#order_newest_first/1"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.order_oldest_first/1","doc":"Order by oldest first","ref":"ElixirExtensions.Ecto.QueryExt.html#order_oldest_first/1"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.preload/2","doc":"Preload associations.\nUserQuery.text_search(\"Kyle\") |> QueryExt.preload(:posts) |> Repo.all()","ref":"ElixirExtensions.Ecto.QueryExt.html#preload/2"},{"type":"function","title":"ElixirExtensions.Ecto.QueryExt.where/2","doc":"Construct a where query on the fly. Only works when `use QueryBuilder` is added to the schema file\neg QueryExt.where(Log, %{post_id: 1814, user_id: 24688, user_type: \"user\"}) |> Repo.all()","ref":"ElixirExtensions.Ecto.QueryExt.html#where/2"},{"type":"module","title":"ElixirExtensions.Ecto.RepoExt","doc":"Extend Repo with some useful functions.\nAdd this line to your repo:\n\ndefmodule MyApp.Repo do\n  use Ecto.Repo,\n    otp_app: :my_app,\n    adapter: Ecto.Adapters.Postgres\n\n  use ElixirExtensions.Ecto.RepoExt\nend","ref":"ElixirExtensions.Ecto.RepoExt.html"},{"type":"extras","title":"ElixirExtensions","doc":"# ElixirExtensions\n\nA set of convenient extensions for developing services with Elixir/Phoenix","ref":"readme.html"},{"type":"extras","title":"Installation - ElixirExtensions","doc":"the package can be installed by adding `elixir_extensions` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:elixir_extensions, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ElixirExtensions","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Core(String,Map) - ElixirExtensions","doc":"- For extending `String`, `Map` utility functions.\n```elixir\n  use ElixirExtensions # import core extentions\n```\n- `underscore_keys`\n```elixir\niex> underscore_keys(%{\"helloWorld\" => \"elixirHi\"})\n%{\"hello_world\" => \"elixirHi\"}\n```\n- `truncate`\n```elixir\niex> truncate(\"hello world\", length: 5)\n\"he...\"\n```\n- `stringify_keys`\n```elixir\niex> stringify_keys(%{hello: \"world\"})\n%{\"hello\" => \"world\"}\n```\n- `slugify`\n```elixir\niex> slugify(\"hello world\")\n\"hello-world\"\n\niex> slugify(\"Hello world\", separator: \"\")    \n\"helloworld\"\n```\n#","ref":"readme.html#core-string-map"},{"type":"extras","title":"Ecto - ElixirExtensions","doc":"- Extend Repo with some useful functions.\n```elixir\n  defmodule MyApp.Repo do\n    use Ecto.Repo,\n      otp_app: :my_app,\n      adapter: Ecto.Adapters.Postgres\n\n    use ElixirExtensions.Ecto.RepoExt # Add this line to your repo.\n  end\n```\n- Extend Changeset with some useful functions.\n```elixir\n defmodule MyApp.Accounts.User do\n    use Ecto.Schema\n    import Ecto.Changeset\n    alias ElixirExtensions.Ecto.ChangesetExt #  Add this line to your schema file.\n    ...\n  end\n```\n- Extend Ecto.Query with some useful functions.\n```elixir\n  import Ecto.Query, warn: false\n  alias ElixirExtensions.Ecto.QueryExt #  Add this line to your Context module file.\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#ecto"}],"content_type":"text/markdown"}